#include "Matrix.h"
#include "Bruch.h"
#include <complex>
#include <time.h>
#include <Windows.h>

using namespace std;

 //Funktionstests
#define check(m)\
    cout << " " << #m << "=" << endl << m << endl;

#define Test(m1,m2,m3,ausdr,bemerk)\
	cout << "+++++++++" << endl << "Test: " << #ausdr << endl;\
    cout << "davor: " << endl << endl;\
    check(m1);\
    check(m2);\
    check(m3);\
	cout << "Testfall: " <<#bemerk<< endl;\
	cout << #ausdr << " = " << endl << ausdr << endl; \
    cout << "danach: " << endl;\
    check(m1);\
    check(m2);\
    check(m3);\
    cout << "+++++++++" << endl;


void fill(Matrix<float>& m);



int main()
{
    Matrix<float> a(3,3),b(3,3),c(3,3),d(2,3),e(3,2),f(3,1),g(3,1),h(3,1),i(2,1);
    float k(3);
    string weiter;

    //Deklaration der Matrizen
	fill(a);
	fill(b);
	fill(c);
	fill(d);
	fill(e);
	fill(f);
	fill(g);
	fill(h);
	fill(i);

   

    //Tests fr Fehlermeldungen

    cout<<"Tests fr Fehlermeldungen: "<<endl;
	try { Test(a,d,c,a+d,"Dimensionsfehler"); } catch (MatrixException ex) {ex.showMsg();}   // a und d haben unterschiedliche Dimension
    try { Test(a,d,c,a-d,"Dimensionsfehler"); } catch (MatrixException ex) {ex.showMsg();}  // " - "
    try { Test(a,d,c,(a+=d),"Dimensionsfehler"); } catch (MatrixException ex) {ex.showMsg();} // " - "	
    try { Test(a,d,c,c*d,"Dimensionsfehler"); } catch (MatrixException ex) {ex.showMsg();}  // Dimension c und d verkehrt
    try { Test(g,h,i,h*i,"Fehler") } catch (MatrixException ex) {ex.showMsg();}            //    Test(a,b,k,a/k,"Fehler")

    system("PAUSE");


    // Tests fr Funktion Addition/Subtraktion
    cout<<"Tests fr Funktion Addition/Subtraktion: "<<endl;
    Test(a,b,c,a+b,"Addition");
    Test(a,b,c,a+b+c,"Addition Kombination");
    Test(a,b,c,(c=a+b),"Addition Zuweisung");
    Test(a,b,c,(a+=b),"Addition");
    Test(a,b,c,a-b,"Subtraktion");
     system("PAUSE");
	Test(a,b,c,a-b-c,"Subtraktion Kombination");
    Test(a,b,c,(a-=b),"Subtraktion");
    Test(a,b,c,a+b-c,"Kombination");
    Test(a,b,c,a-b+c,"Kombination");
    Test(a,b,c,a+b-a,"Kombination");
    
	 system("PAUSE");
	Test(a,b,c,(c=a=b),"Zuweisung Kombination");
    Test(a,b,c,(a=a),"Zuweisung");
    Test(a,b,c,(a==b),"gleich");
    Test(a,b,c,(a!=b),"ungleich");

    system("PAUSE");
    // Tests fr Funktion Multiplikation
    cout<<"Tests fr Funktion Multiplikation: "<<endl;
    Test(a,b,c,a*b,"Multiplikation");
    Test(a,b,c,b*a,"Multiplikation");
    Test(a,b,k,k*a,"Multiplikation mit skalar");
    Test(a,b,k,a*k,"Multiplikation mit skalar");
    Test(f,g,h,f*g,"Vektorprodukt");
    
	 system("PAUSE");
	Test(f,g,h,g*f,"Vektorprodukt");
    Test(f,g,h,f*g*h,"Vektorprodukt Kombination");
    Test(f,g,h,(f*g)*h,"Vektorprodukt Kombination");
    Test(a,b,c,(a*=b),"Multiplikation");
    Test(a,b,c,a*b*c,"Multiplikation Kombination");
    system("PAUSE");
    // Tests fr Kombination Multiplikation und Addition/Subtraktion
    cout<<"Tests fr Funktion Kombination Multiplikation und Addition/Subtraktion: "<<endl;
    Test(a,b,c,a+b*c,"Kombination");
    Test(a,b,c,(a+b)*c,"Kombination");
    Test(a,b,c,(a*(b=a+c)+c),"Kombination");




system("PAUSE");

}



	//	Fllt eine Matrix mit zuflligen Zahlen
	void fill(Matrix<float>& m)
	{
		unsigned int rows = m.getRows();
		unsigned int columns = m.getColumns();
		srand((unsigned int)time(NULL));
		for (unsigned r=1; r<=rows; r++)
			for (unsigned c=1; c<=columns; c++)
				(m)(r,c) = (float)(rand() % 10);
		Sleep(1000);
	}




