/****************************************************************************/
/*																			*/
/*				massentest_solve_bruch.cpp Version 1.8.6					*/
/*																			*/
/*				Fachhochschule Jena - Informatik IIa						*/
/*				Projektarbeit Matrix										*/
/*				Set 2.08													*/
/*				bungsgruppe 1												*/
/*				Projektgruppe 3												*/
/*																			*/
/*				Jrgen Dffinger											*/
/*																			*/
/****************************************************************************/

/****************************************************************************/
/*						Beschreibung:										*/
/*																			*/
/*	Die massentest_solve_bruch.cpp beinhaltet einen Algorithmus zum			*/
/*	testen von einer bestimmten Anzahl linearer Gleichungssystem. Dabei		*/
/*	werden die Gleichungssystem von einem Zufallsgenerator in Gre und		*/
/*	Werten angepasst. Dieses Programm im speziellen testet mit Werten die	*/
/*	vom Datentyp double	sind.												*/
/*																			*/
/****************************************************************************/



#include "Matrix.h"
#include "Bruch.h"
#include <complex>
#include <Windows.h>
#include <time.h>
#include <math.h>
#include <float.h>



//	Funktionsdeklaration
void fill(Matrix<Bruch>& m);
void Ausgabe (Matrix<Bruch>& m);
void Datum();



int main()
{
	cout << "lfd.Nr. ! Koeffizientenmatrix ! absolute Glieder ! Lsung ! Probe ! mittlere Abweichung / % ! Version ! Datum" << endl;
	unsigned short status;	//	Beinhaltet spter den Status der Lsung
							//	Mglich sind die Werte 0, 1 und 2. Dabei gelten fr die Werte folgende Entsprechungen:
							//	0 - keine lsung
							//	1 - eine Lsung
							//	2 - unendlich viele Lsungen
	unsigned int a,b;
	string msg;
	cout.precision(16);
	long double mittlereAbweichung;
	Bruch ref(0);

	//	Test durchfhren
	for (unsigned i=1; i<=10000; i++)
	{
		// Gre des Gleichungssystems festlegen
		srand((unsigned int)time(NULL));
		do {a = (unsigned int)rand() % 10;} while (a<1);
		Sleep(1000);

		//	Matrizen deklarieren und mit Werten fllen lassen
		Matrix<Bruch> A(a), c(a,1), x(a,1), Probe(a,1), Abweichung(a,1);
		fill(A);
		fill(c);

		//	Gleichungssystem lsen
		try { status = A.solve(c,x); }
		catch (MatrixException ex) {msg = ex.getErrorMsg();}


		if (status == 1)
		{
			Probe = A * x;
			Abweichung = c - Probe;
			mittlereAbweichung = 0;
			b = 0;
			for(unsigned r=1; r<=a; r++)
			{
				if (Abweichung(r,1).Zaehler() < 0) Abweichung(r,1) *= (-1);
				if ((c(r,1).Zaehler() / c(r,1).Nenner()) == 0) 
					b--;
				else 
				{
					b++;
					if (c(r,1) < ref) 
						mittlereAbweichung += ((-1) * ((100 * (Abweichung(r,1).Zaehler()/Abweichung(r,1).Nenner())) / (c(r,1).Zaehler()/c(r,1).Nenner())));
					else
						mittlereAbweichung += ((100 * (Abweichung(r,1).Zaehler()/Abweichung(r,1).Nenner())) / (c(r,1).Zaehler()/c(r,1).Nenner()));
				}
			}
			if (b != 0) 
				if (mittlereAbweichung != 0) mittlereAbweichung /= b;
		}
		//	Ergebnis formatiert ausgeben, so dass die umgeleitete Ausgabe in eine Datei, 
		//	spter zur Generierung einer Excel-Datei dienen kann.
		switch(status)
		{
		case 0 : 
			{
				cout << i << " ! ";
				Ausgabe(A);
				cout << " ! ";
				Ausgabe(c);
				cout << " ! keine Loesung ! --- ! --- "; 
				cout << " ! Version 1.8.5 ! ";
				Datum();
				cout << endl;
			} break;
		case 1 : 
			{
				if ((mittlereAbweichung > 100) || (b == 0) || (mittlereAbweichung < 0))
					i--;
				else
				{
					cout << i << " ! ";
					Ausgabe(A);
					cout << " ! ";
					Ausgabe(c);
					cout << " ! ";
					Ausgabe(x);
					cout << " ! ";
					Ausgabe(Probe);
					cout << " ! ";
					cout << mittlereAbweichung;
					cout << " ! Version 1.8.5 ! ";
					Datum();
					cout << endl;
				}
			} break;
		case 2 : 
			{
				cout << i << " ! ";
				Ausgabe(A);
				cout << " ! ";
				Ausgabe(c);
				cout << " ! unendlich viele Loesungen ! --- ! --- "; 
				cout << " ! Version 1.8.5 ! ";
				Datum();
				cout << endl;
			} break;
		}
	}
}



//	Dient dem Auffllen einer Matrix mit zufllig ermittelten Werten
void fill(Matrix<Bruch>& m)
{
	unsigned int rows = m.getRows();
	unsigned int columns = m.getColumns();
	int exp(1);
	long long Z,N;
	srand((unsigned int)time(NULL));
	for (unsigned r=1; r<=rows; r++)
	{
		for (unsigned c=1; c<=columns; c++)	
		{
			do
			{
				Z = rand() % 100;
				if (!(rand() % 2))  Z = -Z;
				N = rand() % 100;
			} while (N == 0);
			m(r,c) = Bruch(Z,N);
		}
	}
	Sleep(1000);	//	Wartezeit von 1 Sekunde, damit beim nchsten mal neue Werte ermittelt werden.
}



//	Dient der formatierten Ausgabe einer Matrix in Zeilenform.
//	Dabei werden Werte durch Komma und Zeilen durch Semikolon getrennt.
void Ausgabe (Matrix<Bruch>& m)
{
	unsigned int rs = m.getRows();
	unsigned int cs = m.getColumns();
	for (unsigned r=1; r<=rs; r++)
	{
		for (unsigned c=1; c<=cs; c++)
		{
			cout << m(r,c);
			if (c != cs) cout << " , ";
		}
		if (r != rs) cout << " ; ";
	}
}



//	Gibt das aktuelle Datum aus
void Datum()
{
	time_t Zeitstempel;
    tm nun;
    Zeitstempel = time(NULL);
	localtime_s(&nun, &Zeitstempel);
    cout << nun.tm_mday << '.' << nun.tm_mon+1 << '.' << nun.tm_year+1900;
}