/****************************************************************************/
/*																			*/
/*				test_solve.cpp Version 1.8.6								*/
/*																			*/
/*				Fachhochschule Jena - Informatik IIa						*/
/*				Projektarbeit Matrix										*/
/*				Set 2.08													*/
/*				bungsgruppe 1												*/
/*				Projektgruppe 3												*/
/*																			*/
/*				Jrgen Dffinger											*/
/*																			*/
/****************************************************************************/

/****************************************************************************/
/*						Beschreibung:										*/
/*																			*/
/*	Die Test_solve.cpp dient dem testen des Gleichungslser der Klasse		*/
/*	Matrix. Hier werden kombinatorische Tests, Funktionstest und			*/
/*	Extremfalltest, sowie Exceptiontests durchgefhrt.						*/		
/*																			*/
/****************************************************************************/



#include <complex>
#include "Matrix.h"
#include "bruch.h"



using namespace std;



template <class T> void Test(T& A, T& c, T& x, unsigned int count, string testname, string type);
template <class T> void Test_Execute(T& A, T& c, T& x, string testname, string type);



int main() 
{
	// Anzahl der Tests einlesen
	unsigned testcount;
	cin >> testcount;

	for(unsigned count=0; count<testcount; count++)
	{
		string testname;	//	Testbezeichnung 
		cin >> testname;	//	einlesen

		string type;	// Datentyp 
		cin >> type;	// einlesen

		//	Matrizen deklarieren und der Tests durchfhren
		if (type == "float") { Matrix<float> A, c, x; Test(A,c,x,count,testname, type); }
		else if (type == "double") { Matrix<double> A, c, x; Test(A,c,x,count,testname, type); }
		else if (type == "complex") { Matrix<complex<double>> A, c, x; Test(A,c,x,count,testname, type); }
		else if (type == "bruch") { Matrix<Bruch> A, c, x; Test(A,c,x,count,testname, type); }
		else cout << "Falsche Datentypangabe." << endl << endl;
	}
	return 0;
}



//	Testfunktion
template <class T> void Test(T& A, T& c, T& x, unsigned int count, string testname, string type)
{
	cout << "********************   Beginn Testfall " << count+1 << "   ********************" << endl << endl;
	
	//	Koeffizientenmatrix definieren und Werte einlesen
	unsigned int zeilen, spalten;
	cin >> zeilen;
	cin >> spalten;
	A.resize(zeilen,spalten);
	cin >> A;
	
	//	Vektor der absoluten Glieder und lsungsvektor deklarieren
	cin >> zeilen;
	cin >> spalten;
	c.resize(zeilen,spalten);
	x.resize(zeilen,spalten);
	cin >> c;	//	Werte der absoluten Glieder einlesen

	//	Test durchfhren
	Test_Execute(A, c, x, testname, type);
	cout << "********************   Ende Testfall " << count+1 << "   ********************" << endl << endl;
}



//	Funktion zur Durchfhrung des  Tests
template <class T> void Test_Execute(T& A, T& c, T& x, string testname, string type)
{ 
	// Ausgabe der Testdaten und des Testergebnisses
	unsigned short s;
	cout << "Test: " << testname << endl; 
	cout << "Type: " << type << endl << endl; 
	cout << "Vorher: " << endl << endl; 
	cout << "Koeffizientenmatrix = " << endl << A << endl << endl; 
	cout << "absolute Glieder = " << endl << c << endl << endl; 
	cout << "Resultat: " << endl << endl; 
	try { s = A.solve(c,x); } 
	catch (MatrixException ex) { ex.showMsg(); } 
	catch (const char *str) {cerr << str << endl;}
	catch (...) {cerr << "unbekannter Fehler" << endl;}
	switch (s) 
	{ 
		case   0 :   cout  << "Das Gleichungssystem hat keine Loesung." << endl; break; 
		case   1 :   cout << x << endl;  break; 
		case   2 :  cout << "Das Gleichungssystem hat unendlich viele Loesungen." << endl; break; 
	} 
	cout << "Nachher: " << endl << endl; 
	cout << "Koeffizientenmatrix = " << endl << A << endl << endl; 
	cout << "absolute Glieder = " << endl << c << endl << endl; 
}
