/****************************************************************************/
/*																			*/
/*				test_solve_exception.cpp Version 1.8.6						*/
/*																			*/
/*				Fachhochschule Jena - Informatik IIa						*/
/*				Projektarbeit Matrix										*/
/*				Set 2.08													*/
/*				bungsgruppe 1												*/
/*				Projektgruppe 3												*/
/*																			*/
/*				Jrgen Dffinger											*/
/*																			*/
/****************************************************************************/

/****************************************************************************/
/*						Beschreibung:										*/
/*																			*/
/*	Die test_solve_exception.cpp beinhaltet die Testroutinen zum testen der	*/
/*	Ausnahmebehandlungen der Klasse Matrix.									*/
/*																			*/
/****************************************************************************/



#include "Matrix.h"



using namespace std;



int main()
{
	Matrix<float> A(3,3),c(3,1),x(3,1);
	unsigned short status;

	// Testfall Exception 400
	//	Vektor der absoluten Glieder darf in diesem Test kein Spaltenvektor sein
	c.resize(3,2);
	try { status = A.solve(c,x); }
	catch (MatrixException ex) { ex.showMsg(); }
	system("PAUSE");

	// Testfall Exception 401
	//	Lsungsvektor darf in diesem Test kein Spaltenvektor sein
	c.resize(3,1);
	x.resize(3,2);
	try { status = A.solve(c,x); }
	catch (MatrixException ex) { ex.showMsg(); }
	system("PAUSE");

	// Testfall Exception 402
	//	Lsungsvektor darf in diesem Test nicht identisch mit
	//	dem Vektor der absoluten Glieder sein
	x.resize(2,1);
	try { status = A.solve(c,x); }
	catch (MatrixException ex) { ex.showMsg(); }
	system("PAUSE");

	// Testfall Exception 403
	//	Die Zeilenanzahl des Vektors der absoluten Glieder 
	//	darf in diesem Test nicht mit der Zeilenanzahl
	//	der Koeffizientenmatrix bereinstimmen.
	c.resize(2,1);
	try { status = A.solve(c,x); }
	catch (MatrixException ex) { ex.showMsg(); }
	system("PAUSE");

	return 0;
}


