/****************************************************************************/
/*																			*/
/*				MatrixException.cpp Version 1.8.6							*/
/*																			*/
/*				Fachhochschule Jena - Informatik IIa						*/
/*				Projektarbeit Matrix										*/
/*				Set 2.08													*/
/*				bungsgruppe 1												*/
/*				Projektgruppe 3												*/
/*																			*/
/*				Jrgen Dffinger											*/
/*																			*/
/****************************************************************************/

/****************************************************************************/
/*						Beschreibung:										*/
/*																			*/
/*	Die Klasse MatrixException behandelt alle Ausnahmen, welche nicht		*/
/*	durch die Standard-Exceptions abgedeckt sind und durch die				*/
/*	Matrix-Klassen verursacht werden.										*/
/*																			*/
/*	Dabei sind folgende Fehlernummer fr die Matrix-Klassen vorgesehen:		*/
/*																			*/
/*	MatrixVector		100 - 199											*/
/*	MatrixArithmetic	200 - 299											*/
/*	MatrixMath			300	- 399											*/	
/*	Matrix				400	- 499											*/	
/*																			*/
/****************************************************************************/



#ifndef MATRIXEXCEPTION_CPP_INCLUDED
#define MATRIXEXCEPTION_CPP_INCLUDED



#include "MatrixException.h"
#include <iostream>
#include <Windows.h>




//	Methode textcolor dient der nderung der Textfarbe
void MatrixException::textcolor(unsigned short color = 15) const 
{
	SetConsoleTextAttribute(::GetStdHandle(STD_OUTPUT_HANDLE), color);
}



// Konstruktoren
MatrixException::MatrixException() : err(-1) {strcpy_s(msg, "unbekannter Fehler");}						//	Standardkonstruktor
MatrixException::MatrixException(unsigned int _err) : err(_err) {strcpy_s(msg, "unbekannter Fehler");}	// Konstruktor zur bernahme der Fehlernummer ohne Fehlermeldung
MatrixException::MatrixException(unsigned int _err, char *_msg) : err(_err) {strcpy_s(msg, _msg);}		//	Konstruktor zur bernahme der Fehlernummer und -meldung
MatrixException::MatrixException(MatrixException& orig) : err(orig.getErrorNumber()) {strcpy_s(msg, orig.getErrorMsg());}	//	Copy - Konstruktor



//	Destruktor
MatrixException::~MatrixException () {}



//	Gibt die Fehlernummer zurck
unsigned int MatrixException::getErrorNumber() const {return err;}



//	Gibt die Fehlermeldung zurck;
char* MatrixException::getErrorMsg() {return msg;}



// Gibt die Fehlermeldung aus.
void MatrixException::showMsg() const
{
	//	Textfarbe auf Rot setzen
	textcolor(12);	
	
	//	Fehlermeldung ausgeben
	std::cout << "Es ist folgender Fehler aufgetreten: " << std::endl;	
	std::cout << msg << std::endl << std::endl;	
	//	Textfarbe auf wei setzen
	textcolor(7);
}

#endif