/****************************************************************************/
/*																			*/
/*				MatrixException.h Version 1.8.6								*/
/*																			*/
/*				Fachhochschule Jena - Informatik IIa						*/
/*				Projektarbeit Matrix										*/
/*				Set 2.08													*/
/*				bungsgruppe 1												*/
/*				Projektgruppe 3												*/
/*																			*/
/*				Jrgen Dffinger											*/
/*																			*/
/****************************************************************************/

/****************************************************************************/
/*						Beschreibung:										*/
/*																			*/
/*	Die Klasse MatrixException behandelt alle Ausnahmen, welche nicht		*/
/*	durch die Standard-Exceptions abgedeckt sind und durch die				*/
/*	Matrix-Klassen verursacht werden.										*/
/*																			*/
/*	Dabei sind folgende Fehlernummer fr die Matrix-Klassen vorgesehen:		*/
/*																			*/
/*	MatrixVector		100 - 199											*/
/*	MatrixArithmetic	200 - 299											*/
/*	MatrixMath			300	- 399											*/	
/*	Matrix				400	- 499											*/	
/*																			*/
/****************************************************************************/



#ifndef MATRIXEXCEPTION_H_INCLUDED
#define MATRIXEXCEPTION_H_INCLUDED



const int MAX=255;	//	maximale Anzahl Zeichen fr die Fehlermeldung



#include <iostream>



class MatrixException {

private:

	unsigned int err;		//	Attribut err beinhaltet die Fehlernummer
	char msg[MAX];			//	Attribut msg enthlt die Fehlermeldung

	void textcolor(unsigned short color) const; //	Methode textcolor dient der nderung der Textfarbe



public:

	MatrixException();									//	Standardkonstruktor
	MatrixException(unsigned int _err);					//	Konstruktor zur bernahme der Fehlernummer ohne Fehlermeldung
	MatrixException(unsigned int _err, char *_msg);		//	Konstruktor zur bernahme der Fehlernummer und -meldung
	MatrixException(MatrixException& orig);				//	Copy - Konstruktor
	virtual ~MatrixException();							//	Destruktor
	unsigned int getErrorNumber() const;				//	Gibt die Fehlernummer zurck	
	char* getErrorMsg();								//	Gibt die Fehlermeldung zurck;
	void showMsg() const;								//	Gibt die Fehlermeldung aus.
};

#endif