/****************************************************************************/
/*																			*/
/*				MatrixCalculator.cpp Version 1.8.6							*/
/*																			*/
/*				Fachhochschule Jena - Informatik IIa						*/
/*				Projektarbeit Matrix										*/
/*				Set 2.08													*/
/*				bungsgruppe  1												*/
/*				Projektgruppe 3												*/
/*																			*/
/*				Jrgen Dffinger											*/
/*																			*/
/****************************************************************************/

/****************************************************************************/
/*						Beschreibung:										*/
/*																			*/
/*	Das Programm MatrixCalculator ist als Anwendungsbeispiel der Klasse		*/
/*	Matrix gedacht. Es knnen alle Eigenschaften einer Matrix abgefragt		*/
/*	werden, sowie die arithmetischen Operatoren verwendet werden. Des		*/
/*	weiteren knnen die Determinante, die Adjunkte,	und die Inverse einer	*/
/*	Matrix gebildet werden, sowie ist es mglich den Gleichungslser zu		*/
/*	verwenden.																*/
/*																			*/
/****************************************************************************/



#include <complex>
#include <conio.h>
#include "Bruch.h"
#include "Matrix.h"
#include <float.h>
#include <Windows.h>



using namespace std;



#define header "MatrixCalculator   Version 1.8.6"
#define msgEingabe "Bitte geben Sie die Werte der Matrixelemente ein. "



//	Vordefinierte Funktion fr Operationen mit zwei Matrizen
#define Exec(m1, m2, expr) \
	system("cls"); \
	cout << header << endl << endl; \
	try {cout << endl << "Ergebnis: " << endl << endl << expr << endl << endl;} \
	catch(MatrixException ex) {ex.showMsg();} \
	catch(const char *str) { \
		Color(0,12); \
		cerr << endl << "Es ist ein Fehler aufgetreten: " << endl << str << endl << endl; \
		Color(0,7); \
	} \
	catch(...) { \
		Color(0,12); \
		cerr << endl << "Es ist ein Fehler aufgetreten: " << endl << "unbekannter Fehler" << endl << endl; \
		Color(0,7); \
	} \
	system("PAUSE");



int TypeDefine();
template <class T> int menu(T& m1, T& m2, T& m3);
int mainmenu();
template <class T> void Eingabe(T& m1, T& m2, T& m3);
template <class T> void resize(T& m);
template <class T> void input(T& m, string msg);
template <class T> void Ausgabe(T& m1, T& m2, T& m3);
template <class T> void output(T& m);
template <class T> void Arithmetic(T& m1, T& m2, T& m3);
template <class T> void MatrixOperationen(T& m1, T& m2, T& m3);
template <class T> void Gleichungsloeser(T& m1, T& m2, T& m3);
void Color(WORD ForeColor, WORD BackColor);



int main()
{
	//	Deklaration
	int Typ; 
	int i;	

	do
	{
		Typ = TypeDefine();	//	Men zur Datentypabfrage aufrufen (TypeDefine)
		switch(Typ)
		{
			case	5	:	return 0; break;	//	Programm beenden

			//	Matrizen anlegen und Hauptmen aufrufen
			case	1	:	{								
								Matrix<float> m1,m2,m3;
								i = menu(m1,m2,m3);
							} break;

			case	2	:	{								
								Matrix<double> m1,m2,m3;
								i = menu(m1,m2,m3);
							} break;

			case	3	:	{
								Matrix<complex<double>> m1,m2,m3;
								i = menu(m1,m2,m3);
							} break;

			case	4	:	{
								Matrix<bruch> m1,m2,m3;
								i = menu(m1,m2,m3);
							} break;
		}
	} while (i != 7);
	return 0;
}
		


//	Hauptmen
template <class T> int menu(T& m1, T& m2, T& m3)
{
	//	Deklaration
	int i;
	
	do
	{
		i = mainmenu(); // mainmenu gibt das Hauptmen aus und liefert die Auswahl des Anwenders zurck
		switch (i)
		{
			case 1	:	Eingabe(m1, m2, m3); break;
			case 2	:	Ausgabe(m1, m2 ,m3); break;
			case 3	:	Arithmetic(m1,m2, m3); break;
			case 4	:	MatrixOperationen(m1,m2,m3); break;
			case 5	:	Gleichungsloeser(m1,m2,m3); break;
		}
	}while ((i != 7) && (i != 6));
	return i;
}



//	Datypauswahlmen
int TypeDefine()
{
	//	Deklaration
	char c;
	int i=1;

	//	Men ausgeben
	do
	{	
		system("cls");
		cout << header << endl << endl; 
		//	Menu ausgeben
		cout << "Bitte waehlen Sie den Datentyp der Matrixelemente:" << endl << endl;
		if (i==1) Color(0,7); else Color(7,0);
		cout << "Dezimalzahl im Bereich von " << FLT_MIN << " bis " << FLT_MAX << endl;
		if (i==2) Color(0,7); else Color(7,0);
		cout << "Dezimalzahl im Bereich von " << DBL_MIN << " bis " << DBL_MAX << endl;
		if (i==3) Color(0,7); else Color(7,0);
		cout << "komplexe Zahlen" << endl;
		if (i==4) Color(0,7); else Color(7,0);
		cout << "Bruchzahl" << endl;
		if (i==5) Color(0,7); else Color(7,0);
		cout << "Programm beenden" << endl;
		Color(7,0);

		//	Auf die Auswahl des Anwenders reagieren
		//	Bei <ENTER> - Taste Schleife beenden und ausgewhlten Menpunkt zurckgeben
		while( !_kbhit() ) {}
		c = _getch();
		if (c == 72) i--;
		if (c == 80) i++;
		if (i > 5) i = 1;
		if (i < 1) i = 5;
	}while (c != 13);
	return i;
}



//	Hauptmen ausgeben und Auswahl zurckgeben
int mainmenu()
{
	//	Deklaration
	char c;
	int i = 1;

	do
	{
		//	Men ausgeben
		system("cls");
		cout << header << endl << endl; 
		cout << endl << "Hauptmenue: " << endl << endl;
		if (i==1) Color(0,7); else Color(7,0);
		cout << "Eingabe" << endl;
		if (i==2) Color(0,7); else Color(7,0);
		cout << "Ausgabe" << endl;
		if (i==3) Color(0,7); else Color(7,0);
		cout << "Arithmetic" << endl;
		if (i==4) Color(0,7); else Color(7,0);
		cout << "Matrix-Operationen" << endl;
		if (i==5) Color(0,7); else Color(7,0);
		cout << "Gleichungsloeser" << endl;
		if (i==6) Color(0,7); else Color(7,0);
		cout << "Datentyp der Matrizen aendern" << endl;
		if (i==7) Color(0,7); else Color(7,0);
		cout << "Programm beenden" << endl;
		Color(7,0);

		//	Bei <ENTER> - Taste Schleife beenden und ausgewhlten Menpunkt zurckgeben
		while( !_kbhit() ) {}
		c = _getch();
		if (c == 72) i--;
		if (c == 80) i++;
		if (i > 7) i = 1;
		if (i < 1) i = 7;
	}while (c != 13);
	return i;
}



/********************************   Eingabe   ********************************/

//	Einagbemen
template <class T> void Eingabe(T& m1, T& m2, T& m3)
{
	//	Deklaration
	char c;
	int i = 1;

	do
	{
		do
		{
			//	Men ausgeben
			system("cls");
			cout << header << endl << endl; 
			cout << endl << "Eingabe - Menue: " << endl << endl;
			if (i==1) Color(0,7); else Color(7,0);
			cout << "Groesze der Matrix 1 anpassen" << endl;
			if (i==2) Color(0,7); else Color(7,0);
			cout << "Groesze der Matrix 2 anpassen" << endl;
			if (i==3) Color(0,7); else Color(7,0);
			cout << "Werte der Matrix 1 eingeben" << endl;
			if (i==4) Color(0,7); else Color(7,0);
			cout << "Werte der Matrix 2 eingeben" << endl;
			if (i==5) Color(0,7); else Color(7,0);
			cout << "Zurueck zum Hauptmenue" << endl;
			Color(7,0);

			//	Bei <ENTER> - Taste Schleife beenden
			while( !_kbhit() ) {}
			c = _getch();
			if (c == 72) i--;
			if (c == 80) i++;
			if (i > 5) i = 1;
			if (i < 1) i = 5;
		}while (c != 13);

		//	Entsprechend der Auswahl des Anwenders Funktionen aufrufen
		//	oder zum Hauptmen zurckkehren
		switch(i)
		{
			case 1	:	resize(m1); break;
			case 2	:	resize(m2); break;
			case 3	:	input(m1, msgEingabe); break;
			case 4	:	input(m2, msgEingabe); break;
		}
	} while (i != 5);
}



//	Gre der Matrix anpassen
template <class T> void resize(T& m)
{
	//	Deklaration
	int zeilen, spalten;

	//	Gre der Matrix abfragen
	system("cls");
	cout << header << endl << endl; 
	cout << endl << "Geben Sie bitte folgende Daten ein:" << endl << endl;
	cout << "Anzahl der Zeilen = ";
	cin >> zeilen;
	cout << "Anzahl der Spalten = ";
	cin >> spalten;

	//	Grenanpassung durchfhren
	try	{m.resize(zeilen, spalten);}
	catch (MatrixException ex) {ex.showMsg(); system("PAUSE");}
}



//	Eingabe der Werte einer Matrix
template <class T> void input(T& m, string msg)
{
	//	Deklaration
	unsigned int rs(m.getRows());
	unsigned int cs(m.getColumns());

	//	Anweisungen zur Eingabe
	system("cls");
	cout << header << endl << endl; 
	cout << "Brueche sind in der Form 1/2 einzugeben, " << endl;
	cout << "also Zaehler und Nenner durch einen Schraegstrich getrennt." << endl << endl;
	cout << "Komplexe Zahlen dagegen sind in der Form (Re,Im) einzugeben. " << endl;
	cout << "Der reale Anteil ist dabei durch Komma vom imaginaeren Anteil getrennt und " << endl;
	cout << "das Ganze muss in Klammern eingeschlossen werden." << endl << endl;
	cout << msg << endl << endl;
		
	//	Eingabe durchfhren
	for(unsigned r=1; r<=rs; r++)
	{
		for(unsigned c=1; c<=cs; c++)
		{
			cout << "Zeile " << r << " , Spalte " << c << " = ";
			cin >> m(r,c);
		}
	}
}



/********************************   Ausgabe   ********************************/

//	Ausgabemen
template <class T> void Ausgabe(T& m1, T& m2, T& m3)
{
	//	Deklaration
	char c;
	int i = 1;

	do
	{
		do
		{
			//	Men ausgeben
			system("cls");
			cout << header << endl << endl; 
			cout << endl << "Ausgabe - Menue: " << endl << endl;
			if (i==1) Color(0,7); else Color(7,0);
			cout << "Matrix 1 ausgeben" << endl;
			if (i==2) Color(0,7); else Color(7,0);
			cout << "Matrix 2 ausgeben" << endl;
			if (i==3) Color(0,7); else Color(7,0);
			cout << "Zurueck zum Hauptmenue" << endl;
			Color(7,0);

			//	Entsprechend der Auswahl des Anwenders Funktionen aufrufen
			//	oder zum Hauptmen zurckkehren
			while( !_kbhit() ) {}
			c = _getch();
			if (c == 72) i--;
			if (c == 80) i++;
			if (i > 3) i = 1;
			if (i < 1) i = 3;
		}while (c != 13);
		switch(i)
		{
			case 1	:	output(m1); break;
			case 2	:	output(m2); break;
		}
	} while (i != 3);
}



//	Gibt eine Matrix aus udn deren Eigenschaften
template <class T> void output(T& m)
{
	//	Deklaration
	unsigned int rs(m.getRows());
	unsigned int cs(m.getColumns());

	//	Eigenschaften ausgeben
	system("cls");
	cout << header << endl << endl; 
	cout << endl << "Eigenschaften der Matrix:" << endl << endl;
	cout << "Zeilen:" << m.getRows() << endl << "Spalten: " << m.getColumns() << endl;
	cout << "quadratische Matrix: "; (m.isSquare()) ? cout << "Ja" : cout << "Nein"; cout << endl;
	cout << "Nullmatrix: "; (m.isZero()) ? cout << "Ja" : cout << "Nein"; cout << endl;
	cout << "Einheitsmatrix: "; (m.isUnit()) ? cout << "Ja" : cout << "Nein"; cout << endl;
	cout << "Skalarmatrix: "; (m.isScalar()) ? cout << "Ja" : cout << "Nein"; cout << endl;
	cout << "Dreiecksmatrix: ";
	switch(m.isTriangular())
	{
		case 0	:	cout << "keine"; break;
		case 1	:	cout << "obere"; break;
		case 2	:	cout << "untere"; break;
		case 3	:	cout << "Diagonalmatrix (beinhaltet obere und untere Dreiecksmatrix)"; break;
	}
	cout << endl;
	cout << "Spaltenvektor: "; (m.isColumnVector()) ? cout << "Ja" : cout << "Nein"; cout << endl;
	cout << "Zeilenvektor: "; (m.isRowVector()) ? cout << "Ja" : cout << "Nein"; cout << endl;

	//	Ausgabe der Werte
	cout << endl << "Werte der Matrix: " << endl << endl << m << endl;

	system("PAUSE");
}



/********************************   Arithmetic   ********************************/

//	Arithmeticmen
template <class T> void Arithmetic(T& m1, T& m2, T& m3)
{
	//	Deklaration
	char c;
	int i = 1;

	do
	{
		do
		{
			//	Men ausgeben
			system("cls");
			cout << header << endl << endl;
			cout << endl << "Arithmetic - Menue: " << endl << endl;
			if (i==1) Color(0,7); else Color(7,0);
			cout << "Matrix 1 + Matrix 2" << endl;
			if (i==2) Color(0,7); else Color(7,0);
			cout << "Matrix 1 - Matrix 2" << endl;
			if (i==3) Color(0,7); else Color(7,0);
			cout << "Matrix 1 * Matrix 2" << endl;
			if (i==4) Color(0,7); else Color(7,0);
			cout << "Zurueck zum Hauptmenue" << endl;
			Color(7,0);

			//	Entsprechend der Auswahl des Anwenders Anweisung und Objekte an
			//	Prprozessordefinierte Funktion Exec bergeben
			//	oder zum Hauptmen zurckkehren
			while( !_kbhit() ) {}
			c = _getch();
			if (c == 72) i--;
			if (c == 80) i++;
			if (i > 4) i = 1;
			if (i < 1) i = 4;
		}while (c != 13);
		switch(i)
		{
			case 1	:	Exec(m1, m2, m1 + m2); break;	//	Addition ausfhren
			case 2	:	Exec(m1, m2, m1 - m2); break;	//	Subtraktion durchfhren
			case 3	:	Exec(m1, m2, m1 * m2) break;	//	Multiplikation durchfhren
		}
	} while (i != 4);
}



/********************************   Matrix - Operationen   ********************************/

//	Matrix-Operationen-Men
template <class T> void MatrixOperationen(T& m1, T& m2, T& m3)
{
	//	Deklaration
	char c;
	int i = 1;

	do
	{
		do
		{
			// Men ausgeben
			system("cls");
			cout << header << endl << endl; 
			cout << endl << "Matrix - Operationen - Menue: " << endl << endl;
			if (i==1) Color(0,7); else Color(7,0);
			cout << "Determinante Matrix 1" << endl;
			if (i==2) Color(0,7); else Color(7,0);
			cout << "Determinante Matrix 2" << endl;
			if (i==3) Color(0,7); else Color(7,0);
			cout << "Adjunkte Matrix 1" << endl;
			if (i==4) Color(0,7); else Color(7,0);
			cout << "Adjunkte Matrix 2" << endl;
			if (i==5) Color(0,7); else Color(7,0);
			cout << "Inverse Matrix 1" << endl;
			if (i==6) Color(0,7); else Color(7,0);
			cout << "Inverse Matrix 2" << endl;
			if (i==7) Color(0,7); else Color(7,0);
			cout << "Zurueck zum Hauptmenue" << endl;
			Color(7,0);

			//	Entsprechend der Auswahl des Anwenders Anweisung und Objekte an
			//	Prprozessordefinierte Funktion Exec bergeben
			//	oder zum Hauptmen zurckkehren
			while( !_kbhit() ) {}
			c = _getch();
			if (c == 72) i--;
			if (c == 80) i++;
			if (i > 7) i = 1;
			if (i < 1) i = 7;
		}while (c != 13);
		switch(i)
		{
			case 1	:	Exec(m1, m2, m1.determinante()); break;
			case 2	:	Exec(m2, m1, m2.determinante()); break;
			case 3	:	Exec(m1, m2, m1.adjunkte()) break;
			case 4	:	Exec(m2, m1, m2.adjunkte()); break;
			case 5	:	Exec(m1, m2, m1.inverse()); break;
			case 6	:	Exec(m2, m1, m2.inverse()) break;
		}
	} while (i != 7);
}



/********************************   Gleichungslser   ********************************/

template <class T> void Gleichungsloeser(T& m1, T& m2, T& m3)
{
	system("cls");
	cout << header << endl << endl; 

	//	Deklaration
	unsigned int k;	// Anzahl Koeffizienten;

	//	Eingabe der Dimension des linearen Gleichungssystems
	cout << endl << "Gleichungsloeser:" << endl;
	cout << endl << "Anzahl der Koeffizienten: ";
	cin >> k;

	//	Deklaration der Matrizen und Vektoren des Gleichungssystems
	T mK(k,k);	// Koeffizientenmatrix
	T sV(k,1);	// Spaltenvektor der absoluten Glieder
	T lV(k,1);	// Lsungsvektor
	unsigned short status;	//	Status der Lsung

	//	Einlesen der Koeffizienten
	system("cls");
	cout << header << endl << endl; 
	input(mK, "Geben Sie bitte die Koeffizientenmatrix ein: ");

	//	Einlesen der absoluten Glieder
	system("cls");
	cout << header << endl << endl; 
	input(sV,"Geben Sie bitte den Spaltenvektor der absoluten Glieder ein: ");

	// Gleichungssystem lsen und Lsung ausgeben
	system("cls");
	cout << header << endl << endl; 
	cout << endl << "Ergebnis: " << endl << endl;
	try { status = mK.solve(sV,lV); }
	catch (MatrixException ex) {ex.showMsg();}
	switch(status)
	{
		case 0	:	cout << "Das Gleichungssystem hat keine Loesung." << endl << endl; break;

		case 1	:	{
						for(unsigned r=1; r<=k; r++)
							cout << "x" << r << " = " << lV(r,1) << endl;
						cout << endl;
					} break;

		case 2	:	cout << "Das Gleichungssystem hat unendlich viele Loesungen." << endl << endl; break;

	}
	system("PAUSE");
}



/********************************   Hilfsfunktionen   ********************************/

//	ndert die Vorder- und Hintergrundfarbe
void Color(WORD ForeColor, WORD BackColor)
{
	SetConsoleTextAttribute(::GetStdHandle(STD_OUTPUT_HANDLE), (WORD) ( (BackColor << 4) | ForeColor));
}
